import 'package:osam/osam.dart';

void main() {
  final c = Counter();
  c.value.addListener(() {
    print(c.value);
    print(c._attempts.value);
  });
  c.increment();
  c.increment();
  c.increment();
}

class Counter {
  final _value = PropertyNotifier(0);
  final _attempts = PropertyNotifier(<String>[]);

  void increment() => _value.value++;

  IProperty<int> get value => _value;

  Counter() {
    value.addListener(() {
      _attempts.update((value) => value.add('added ${_value.value}'));
    });
  }
}
